//+------------------------------------------------------------------+
//|                                                    3HiLow_v2.mq4 |
//|                                        Copyright  2011, Snail09 |
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Snail09"
#property link      "noLink"
//***************************************************
extern double Lots      = 0.01;     //   ( MaxRisk=0)
//extern double MaxRisk = 0.0;      //       
                                    // ( 0 -  )
extern int Candles      = 3;        //  
extern int IgnoreSignal = 2;        //   ,  
                                    //   
//***************************************************
int MagicNumber;                    //  
string ExpertName;                  //   
bool IsExpertStopped    = false;
bool TradeAllowed;                  //      ?
int CurSignal;                      //   
int slippage            = 30;       // 
//   
int _Ticket=0, _Type=0;

//double MinLot,MaxLot,StartLots;      //  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
   {
   IsExpertStopped = false;
   if (!IsTradeAllowed())
      {
      Comment("   ");
      IsExpertStopped = true;
      return (0);
      }
      
   if (!IsTesting())
      {
      if (IsExpertEnabled())  Comment("   ");       
      else  Comment("  \"  \"");
      }
   
   MagicNumber= 2000 + 
         func_Symbol2Val(Symbol()) * 100 + 
         func_TimeFrame_Const2Val(Period());
   ExpertName= "3HiLow_v2:" + 
         MagicNumber + ":" + 
         Symbol() +  
         func_TimeFrame_Val2String(func_TimeFrame_Const2Val(Period()));
   CurSignal=IgnoreSignal;
   return(0);
   }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   static datetime PrevTime=0;   //    

   //   
   string TextComment="\n" + "ExpertName= " + ExpertName + "\n";
   TextComment=TextComment + " = " + Candles + "\n";
   TextComment=TextComment + " = " + IgnoreSignal;
   Comment(TextComment);

   /*      100   ,    
    -     */
   if (Bars<100 || !IsTradeAllowed() || IsTradeContextBusy() || !IsConnected()) return;

   if (PrevTime==0) PrevTime=Time[0];  //      
   if (Time[0]<=PrevTime) return(0);   //     

   GetInfo();     //  
   
   //    ,   
   if (!TradeAllowed) return(0);
   
   OrdersBlock(); //    
    
   PrevTime=Time[0]; //     

   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Numeric value for symbol name
//+------------------------------------------------------------------+
int func_Symbol2Val(string symbol) {
     if(symbol=="AUDCAD") {
        return(1);
     } else if(symbol=="AUDJPY") {
        return(2);
     } else if(symbol=="AUDNZD") {
        return(3);
     } else if(symbol=="AUDUSD") {
        return(4);
     } else if(symbol=="CHFJPY") {
        return(5);
     } else if(symbol=="EURAUD") {
        return(6);
     } else if(symbol=="EURCAD") {
        return(7);
     } else if(symbol=="EURCHF") {
        return(8);
     } else if(symbol=="EURGBP") {
        return(9);
     } else if(symbol=="EURJPY") {
        return(10);
     } else if(symbol=="EURUSD") {
        return(11);
     } else if(symbol=="GBPCHF") {
        return(12);
     } else if(symbol=="GBPJPY") {
        return(13);
     } else if(symbol=="GBPUSD") {
        return(14);
     } else if(symbol=="NZDUSD") {
        return(15);
     } else if(symbol=="USDCAD") {
        return(16);
     } else if(symbol=="USDCHF") {
        return(17);
     } else if(symbol=="USDJPY") {
        return(18);
     } else if(symbol=="XAUUSD") {
        return(19);
     } else if(symbol=="XAGUSD") {
        return(20);
     } else if(symbol=="XAUEUR") {
        return(21);
     } else if(symbol=="XAGEUR") {
        return(22);
     } else {
        Comment("unexpected Symbol");
        return(0);
     }
}

//+------------------------------------------------------------------+
//| Time frame interval appropriation function                      |
//+------------------------------------------------------------------+
int func_TimeFrame_Const2Val(int Constant) {
     switch(Constant) {
         case     1: return(1);
         case     5: return(2);
         case    15: return(3);
         case    30: return(4);
         case    60: return(5);
         case   240: return(6);
         case  1440: return(7);
         case 10080: return(8);
         case 43200: return(9);
     }
}

//+------------------------------------------------------------------+
//| Time frame string appropriation  function                        |
//+------------------------------------------------------------------+
string func_TimeFrame_Val2String(int Value) {
    switch(Value) {
        case 1: return("_M1");
        case 2: return("_M5");
        case 3: return("_M15");
        case 4: return("_M30");
        case 5: return("_H1");
        case 6: return("_H4");
        case 7: return("_D1");
        case 8: return("_W1");
        case 9: return("_MN1");
        default: return("undefined " + Value);
    }
}

//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void GetInfo()
   {
   int op=0;
   _Ticket=0; _Type=0;
   
   //        
   for(int i=0;i<=OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         {
         //      -   
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
            {
            //    
            _Ticket= OrderTicket();
            _Type=   OrderType();
            if(_Type==OP_BUY || _Type==OP_SELL) op++;
            }
         }
     }
     
   if(op>1)                //    
      {
      TradeAllowed=false;
      Alert("  !    1- !");
      }
   else TradeAllowed=true; //       
   }

//+------------------------------------------------------------------+
//|   ( )
//+------------------------------------------------------------------+
void OrdersBlock()
   {
   int MaxLow=0, MinHigh=0;
      
   for(int i=1;i<=Candles;i++)   //    
      { 
      if(Low[i+1]<Low[i])     MaxLow++;    // 
      if(High[i+1]>High[i])   MinHigh++;   // 
      }

   if(MaxLow==Candles && MinHigh==Candles)   //    
      {CurSignal=0; return(0);}

   if(MaxLow==Candles)  // 
      {
      if(_Type==0) {OpenBuy(); return(0);}
      if(_Type==OP_BUY)
         {
         if(CurSignal>=1)  {CurSignal--; return(0);}
         else              OpenBuy();
         }
      if(_Type==OP_SELL)
         {CurSignal=IgnoreSignal; OpenBuy(); return(0);}
      }

   if(MinHigh==Candles) // 
      {
      if(_Type==0) {OpenSell(); return(0);}
      if(_Type==OP_SELL)
         {
         if(CurSignal>=1)  {CurSignal--; return(0);}
         else              OpenSell();
         }
      if(_Type==OP_BUY)
         {CurSignal=IgnoreSignal; OpenSell(); return(0);}
      }
   }

//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void OpenBuy()
   {
   int it;
   //StartLots=Get_Lots();

   if(_Type==OP_BUY)
      {
      for (it=1; it<=5; it++)
         {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         if(OrderClose(_Ticket,Lots,Bid,slippage,White)>=0)
            break;
         Sleep(5000);
         }
      }
   
   if(_Type==OP_SELL)
      {
      for (it=1; it<=5; it++)
         {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         if(OrderClose(_Ticket,Lots,Ask,slippage,White)>=0)
            break;
         Sleep(5000);
         }
      }
   
   for (it=1; it<=5; it++)
      {
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      if(OrderSend(Symbol(),OP_BUY,Lots,Ask,slippage,0,0,ExpertName,MagicNumber,0,Blue)>=0)
         break;
      Sleep(5000);
      }
   }

//+------------------------------------------------------------------+
//|  
//+------------------------------------------------------------------+
void OpenSell()
   {
   int it;
   //StartLots=Get_Lots();
   
   if(_Type==OP_BUY)
      {
      for (it=1; it<=5; it++)
         {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         if(OrderClose(_Ticket,Lots,Bid,slippage,White)>=0)
            break;
         Sleep(5000);
         }
      }
   
   if(_Type==OP_SELL)
      {
      for (it=1; it<=5; it++)
         {
         while (!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         if(OrderClose(_Ticket,Lots,Ask,slippage,White)>=0)
            break;
         Sleep(5000);
         }
      }
   
   for (it=1; it<=5; it++)
      {
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      if(OrderSend(Symbol(),OP_SELL,Lots,Bid,slippage,0,0,ExpertName,MagicNumber,0,Red)>=0)
         break;
      Sleep(5000);
      }
   }

//+------------------------------------------------------------------+
//|    
//+------------------------------------------------------------------+
/*
   double Get_Lots() 
   {
   double lot=Lots;
   if (MaxRisk>0) 
      {
      double RiskSumm=AccountFreeMargin()*MaxRisk;
      lot=RiskSumm/Order_SL/100;
      }
   return(LotNormalize(lot));
   }
*/

//+------------------------------------------------------------------+
//|   
//+------------------------------------------------------------------+
/*
   double LotNormalize(double x)
   {
   x=MathFloor(x*100)/100;
   if (x>MaxLot) x=MaxLot;
   if (x<MinLot) x=MinLot;
   return(x);
   }
*/